<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml\Form\Export.
 */
 
 
 
namespace Drupal\miniorange_saml\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml\MiniorangeSamlSupport;
use Drupal\miniorange_saml\Utilities;

include 'includes\miniorange_saml_enums.php';

define("Tab_Class_Names", serialize( array(
    "Identity_Provider" => 'mo_options_enum_identity_provider',
    "Service_Provider"  => 'mo_options_enum_service_provider',
) ) );



class Export extends FormBase
{	
  public function getFormId() 
  {
    return 'miniorange_saml_export';
  }
  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) 
  {
      global $base_url;
		if (\Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_email') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_id') == NULL
		|| \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_token') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_api_key') == NULL) 
		{
            $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
            $form['header'] = array(
                '#markup' => '<center><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
            );
            return $form;
		}

        $form['markup_top'] = array(
            '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout container">'
        );

		$form['markup_top_1'] = array
		(
			'#markup' => '<h3>Export Configuration</h3><hr/><p>This tab will help you to transfer your plugin configurations when you change your Drupal instance.</p>'
            . '<p>Download plugin configuration file by clicking on the button given below and send us this file along with your support query. <br/></p>'
		);

      $login_URL = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_login_url');
      $ACS_URL = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_issuer');
      $disableButton = FALSE;
      if($login_URL == NULL || $ACS_URL == NULL){
          $disableButton = TRUE;
          $form['markup_note'] = array(
              '#markup' => '<div class="mo_saml_highlight_background_note_1"><p><b>Note:</b> Please <a href="' . $base_url . '/admin/config/people/miniorange_saml/sp_setup">configure plugin </a> first to download configuration file</p></div><br>',
          );
      }

		$form['miniorange_saml_imo_option_exists_export'] = array(
			'#type' => 'submit',
			'#value' => t('Download Plugin Configuration'),
			'#submit' => array('::miniorange_import_export'),
            '#disabled' => $disableButton,
		);

        $form['markup_import'] = array(
            '#markup' => '<br/><br/><br/><h3>Import Configuration <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b></h3>' .'<hr/>' . '<p>This tab will help you to<span style="font-weight: bold"> Import your plugin configurations</span> when you change your Drupal instance.</p>'
                . '<p>choose <b>"json"</b> Extened plugin configuration file and upload by clicking on the button given below. </p>'
        );

        $form['import_Config_file'] = array(
            '#type' => 'file',
            '#disabled' => TRUE,
        );

      $form['miniorange_saml_idp_import'] = array(
          '#type' => 'submit',
          '#value' => t('Upload'),
          '#disabled' => TRUE,
      );

      $form['markup_support_1'] = array(
          '#markup' => '<br><br></div><div class="mo_saml_table_layout_support_1"><h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
      );
      $RegisteredEmailandPhone = Utilities::getEmailandPhone();
      $form['miniorange_saml_email_address_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array(
              'placeholder' => 'Enter your Email'
          ),
          '#default_value' => $RegisteredEmailandPhone['email'],
      );

      $form['miniorange_saml_phone_number_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array(
              'placeholder' => 'Enter your Phone Number'
          ),
          '#default_value' => $RegisteredEmailandPhone['phone'],
      );

      $form['miniorange_saml_support_query_support'] = array(
          '#type' => 'textarea',
          '#clos' => '10',
          '#rows' => '5',
          '#attributes' => array(
              'placeholder' => 'Write your query here'
          ),
      );

      $form['miniorange_saml_support_submit_click'] = array(
          '#type' => 'submit',
          '#value' => t('Submit Query'),
      );

      $form['miniorange_saml_support_note'] = array(
          '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div>'
      );

      $form['miniorange_saml_support_div_cust'] = array(

          '#markup' => '</div></div>'
      );
		return $form;
	}
	function miniorange_import_export() 
	{
		$tab_class_name = unserialize(Tab_Class_Names);
		$configuration_array = array();
		foreach($tab_class_name as $key => $value) 
		{	
			$configuration_array[$key] = $this -> mo_get_configuration_array($value);	
		}
		$configuration_array["Version_dependencies"] = $this -> mo_get_version_informations();
		header("Content-Disposition: attachment; filename = miniorange_saml_config.json");
		echo(json_encode($configuration_array, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES));
		exit;
	}

function mo_get_configuration_array($class_name) 
{
	if($class_name == "mo_options_enum_identity_provider")
	{
		$class_object = \Drupal\miniorange_saml\mo_options_enum_identity_provider:: getConstants();
	}
	else if($class_name == "mo_options_enum_service_provider")
	{
		$class_object = \Drupal\miniorange_saml\mo_options_enum_service_provider:: getConstants();
	}
    $mo_array = array();
    foreach($class_object as $key => $value) 
	{ 
        $mo_option_exists = \Drupal::config('miniorange_saml.settings')->get($value);	
	    if($mo_option_exists)
		{
            if(unserialize($mo_option_exists) !== false)
			{
                $mo_option_exists = unserialize($mo_option_exists);
            }
            $mo_array[$key] = $mo_option_exists;
        }
    }
    return $mo_array;
}



    function mo_get_version_informations()
    {
        $array_version = array();
        $array_version["PHP_version"] = phpversion();
        $array_version["Drupal_version"] = VERSION;
        $array_version["OPEN_SSL"] = $this -> mo_saml_is_openssl_installed();
        $array_version["CURL"] = $this -> mo_saml_is_curl_installed();
        $array_version["ICONV"] = $this -> mo_saml_is_iconv_installed();
        $array_version["DOM"] = $this -> mo_saml_is_dom_installed();
        return $array_version;
    }

	function mo_saml_is_openssl_installed()
	{
		if ( in_array( 'openssl', get_loaded_extensions() ) ) 
		{
			return 1;
		} 
		else
		{
			return 0;
		}
	}
    function mo_saml_is_curl_installed() {
        if ( in_array( 'curl', get_loaded_extensions() ) ) {
            return 1;
        } else {
            return 0;
        }
    }
    function mo_saml_is_iconv_installed(){

        if ( in_array( 'iconv', get_loaded_extensions() ) ) {
            return 1;
        } else {
            return 0;
        }
    }
    function mo_saml_is_dom_installed(){

        if ( in_array( 'dom', get_loaded_extensions() ) ) {
            return 1;
        } else {
            return 0;
        }
    }
	public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $email = $form['miniorange_saml_email_address_support']['#value'];
        $phone = $form['miniorange_saml_phone_number_support']['#value'];
        $query = $form['miniorange_saml_support_query_support']['#value'];
        $support = new MiniOrangeSamlSupport($email, $phone, $query);
        $support_response = $support->sendSupportQuery();
        if($support_response) {
            drupal_set_message(t('Support query successfully sent'));
        }
        else {
            drupal_set_message(t('Error sending support query'), 'error');
        }
	}
		
}