<?php
/**
 * @file
 * Contains Attribute and Role Mapping for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
namespace Drupal\miniorange_saml\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml\MiniorangeSamlSupport;
use Drupal\miniorange_saml\Utilities;

 class Mapping extends FormBase {
	 
  public function getFormId() {
    return 'miniorange_saml_mapping';
  }
	 
 public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {

      global $base_url;
  if (\Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_email') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_id') == NULL
    || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_token') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_api_key') == NULL) {
      $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
      $form['header'] = array(
          '#markup' => '<center><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
      );

    return $form;
  }
  
  global $base_url;

     $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',
     );

     $form['markup_top'] = array(
         '#markup' => '<div class="mo_saml_table_layout container">'
     );

     $form['markup_idp_attr_header'] = array(
         '#markup' => '<h3>Attribute Mapping (Optional)</h3>',
     );

     $form['miniorange_saml_account_username_by'] = array(
    '#type' => 'select',
    '#title' => t('Login/Create Drupal account by'),
    '#options' => array(
      1 => t('Drupal Email Address'),
      2 => t('Drupal Username'),
    ),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_login_by'),
    '#attributes' => array('style' => 'width:700px'),
  );

  $form['miniorange_saml_username_attribute'] = array(
    '#type' => 'textfield',
    '#title' => t('Username Attribute'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_username_attribute'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Username attribute'),
	'#disabled' => TRUE,
  );

  $form['miniorange_saml_email_attribute'] = array(
    '#type' => 'textfield',
    '#title' => t('Email Attribute'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_email_attribute'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Email attribute'),
	'#disabled' => TRUE,
  );
  
$form['miniorange_saml_idp_attr1_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Role <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b>'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_attr1_name'),
    '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Role Attribute'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
 
  $form['markup_cam'] = array(
    '#markup' => '<br><h3>Custom Attribute Mapping <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b></h3>
                  <div class="mo_saml_highlight_background_note_1"><p><b>NOTE: </b> Add the Drupal field attributes in the Attribute Name textfield and add the IdP attibutes that you need to map with the drupal attributes in the IdP Attribute Name textfield. Drupal Field Attributes will be of type text. Add the machine name of the attribute in the Drupal Attribute textfield.</p></div><p><b>For example: If the attribute name in the drupal is name then its machine name will be field_name.</b></p>',
  );
  
   $form['miniorange_saml_attr5_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 1 <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a>'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_attr5_name'),
       '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr5_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 1'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_attr5_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr2_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 2 <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a>'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_attr2_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr2_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 2'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_attr2_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr3_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 3 <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a> '),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_attr3_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr3_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 3'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_attr3_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr4_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 4 <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a>'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_attr4_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr4_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 4'),
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_attr4_name'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
   $form['markup_role'] = array(
    '#markup' => '<br><h3>Role Mapping</h3>',
  );
  

$form['miniorange_saml_enable_rolemapping'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>enable Role Mapping</b>'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_enable_rolemapping'),
  );
  
   $form['miniorange_saml_disable_autocreate_users'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to disable <b>auto creation</b> of users if user does not exist. <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b><br/><br/>'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_disable_autocreate_users'),
	'#disabled' => TRUE,
  );
  
	$mrole = user_role_names(TRUE);
	$def_role = \Drupal::configFactory()->getEditable('miniorange_saml.settings')->get('miniorange_saml_def_role');
	
     $form['miniorange_saml_default_mapping'] = array(
    '#type' => 'select',
	'#title' => t('Select default group for the new users'),
	'#options' => array_keys($mrole),
	'#default_value' => $def_role,
    '#attributes' => array('style' => 'width:700px'),
   );
    
	$form['markup_role_map'] = array(
    '#markup' => '<br><h3>Custom Role Mapping <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b></h3>',
   );
  
   foreach($mrole as $roles) {
    $rolelabel = str_replace(' ','',$roles);
    $form['miniorange_saml_role_' . $rolelabel] = array(
	'#type' => 'textfield',
	'#title' => t($roles),
	'#maxlength' => 255,
	'#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_role_' . $rolelabel),
        '#attributes' => array('style' => 'width:700px','placeholder' => 'Semi-colon(;) separated Group/Role value for ' . $roles),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  }
   
  $form['miniorange_saml_gateway_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Configuration'),
  );

     $form['main_layout_div_end'] = array(
         '#markup' => '<br><br></div>',
     );

     $form['markup_idp_attr_header_top_support'] = array('#markup' => '<div class="mo_saml_table_layout_support_1">',
     );

     $form['markup_support_1'] = array(
         '#markup' => '<h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
     );

     $RegisteredEmailandPhone = Utilities::getEmailandPhone();
     $form['miniorange_saml_email_address_support'] = array(
         '#type' => 'textfield',
         '#attributes' => array(
             'placeholder' => 'Enter your Email'
         ),
         '#default_value' => $RegisteredEmailandPhone['email'],
     );

     $form['miniorange_saml_phone_number_support'] = array(
         '#type' => 'textfield',
         '#attributes' => array(
             'placeholder' => 'Enter your Phone Number'
         ),
         '#default_value' => $RegisteredEmailandPhone['phone'],
     );

     $form['miniorange_saml_support_query_support'] = array(
         '#type' => 'textarea',
         '#clos' => '10',
         '#rows' => '5',
         '#attributes' => array(
             'placeholder' => 'Write your query here'
         ),
     );

     $form['miniorange_saml_support_submit_click'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('::saved_support'),
     );

     $form['miniorange_saml_support_note'] = array(
         '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div>'
     );

     $form['miniorange_saml_support_div_cust'] = array(

         '#markup' => '</div></div>'
     );
  return $form;

 }

     function saved_support($form, &$form_state)
     {
         $email = $form['miniorange_saml_email_address_support']['#value'];
         $phone = $form['miniorange_saml_phone_number_support']['#value'];
         $query = $form['miniorange_saml_support_query_support']['#value'];
         $support = new MiniOrangeSamlSupport($email, $phone, $query);
         $support_response = $support->sendSupportQuery();
         if($support_response) {
             drupal_set_message(t('Support query successfully sent'));
         }
         else {
             drupal_set_message(t('Error sending support query'), 'error');
         }
     }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
  $mrole = user_role_names(TRUE);
  $login_by = $form['miniorange_saml_account_username_by']['#value'];
  $username_attribute = $form['miniorange_saml_username_attribute']['#value'];
  $email_attribute = $form['miniorange_saml_email_attribute']['#value'];
  $default_mapping= $form['miniorange_saml_default_mapping']['#value'];  
  $enable_rolemapping = $form['miniorange_saml_enable_rolemapping']['#value']; 
  $i = 0;
  foreach($mrole as $key => $value) {
		$def_role[$i] = $value;
        $i++;
  }
	
  if($enable_rolemapping == 1) {
		$enable_rolemapping = TRUE;
	}
	else {
		$enable_rolemapping = FALSE;
	}
	
	if($enable_rolemapping) {
		\Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_default_role', $def_role[$default_mapping]);
		\Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_def_role', $default_mapping);
	}
	else {
	 \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_default_role', $mrole['authenticated'])->save();
	}
 
  \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_login_by', $login_by)->save();
  \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_username_attribute', $username_attribute)->save();
  \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_email_attribute', $email_attribute)->save();
  \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_enable_rolemapping', $enable_rolemapping)->save();
  drupal_set_message(t('Signin Settings successfully saved'));
  }
  }