<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml\Form\MiniorangeIDPSetup.
 */

namespace Drupal\miniorange_saml\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml\MiniorangeSamlSupport;
use Drupal\miniorange_saml\Utilities;


class MiniorangeIDPSetup extends FormBase {

  public function getFormId() {
    return 'miniorange_saml_idp_setup';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {

   global $base_url;
  if (\Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_email') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_id') == NULL
    || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_token') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_api_key') == NULL) {
      $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
      $form['header'] = array(
          '#markup' => '<h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3>',
      );

    return $form;
  }
  
  global $base_url;
  $url = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_base_url');
  $issuer = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_entity_id');
  
  $b_url = isset($url) && !empty($url)? $url:$base_url;
  $issuer_id = isset($issuer) && !empty($issuer)? $issuer:$base_url;
  
  
  $acs_url = $b_url . '/samlassertion';

      $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',
      );

      $form['markup_top'] = array(
          '#markup' => '<div class="mo_saml_table_layout container">'
      );

  $form['miniorange_saml_base_url'] = array(
    '#type' => 'textfield',
    '#title' => t('SP Base URL: <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a>'),
    '#default_value' => $b_url,
      '#attributes' => array('style' => 'width:700px'),
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_entity_id'] = array(
    '#type' => 'textfield',
    '#title' => t('SP Entity ID/Issuer: <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a>'),
    '#default_value' => $issuer_id,
      '#attributes' => array('style' => 'width:700px'),
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_default_relaystate'] = array(
    '#type' => 'textfield',
    '#title' => t('Default Redirect URL after login <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a>'),
    '#default_value' => $base_url,
      '#attributes' => array('style' => 'width:700px'),
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
	'#disabled' => TRUE,
  );
  
  $form['header'] = array(
    '#markup' => '<br/><br/><div class="mo_saml_text_center"><h3>You will need the following information to'
    . ' configure your IdP. Copy it and keep it handy</h3></div>',
  );

  $header = array(
    'attribute' => array('data' => t('Attribute')),
    'value' => array('data' => t('Value')),
  );

  $options = array();

  $options[0] = array(
    'attribute' => t('Issuer'),
    'value' => $issuer_id,
  );

  $options[1] = array(
    'attribute' => t('ACS URL'),
    'value' => $acs_url,
  );

  $options[2] = array(
    'attribute' => t('Audience URI'),
    'value' => $b_url,
  );

  $options[3] = array(
    'attribute' => t('Recipient URL'),
    'value' => $acs_url,
  );

  $options[4] = array(
    'attribute' => t('Destination URL'),
    'value' => $acs_url,
  );

  $options[5] = array(
    'attribute' => t('Single Logout URL'),
    'value' => t('Available in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Premium</a></b> version of the module'),
  );
  
  $options[6] = array(
    'attribute' => t('NameID Format'),
    'value' => 'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress',
  );

  $form['fieldset']['spinfo'] = array(
    '#theme' => 'table',
    '#header' => $header,
    '#rows' => $options,
  );
  
  $form['markup_sp_md_1'] = array(
    '#markup' => 'You can provide this metadata URL to your Identity Provider.<br />',
  );

  $form['markupsp_sp_md_2'] = array(
    '#markup' => '<div class="mo_saml_highlight_background_note"><code style="background-color:gainsboro;"><b>'
	. '<a target="_blank" href="' . $b_url . '/modules/miniorange_saml/includes/metadata/metadata.php">' . $b_url . '/modules/miniorange_saml/includes/metadata/metadata.php' . '</a></b></code></div>',
  );

  $form['markup_13'] = array(
    '#markup' => '<br/><h3>Identity Provider Guides</h3>',
  );

  $form['markup_14'] = array(
    '#markup' => 'With the help of the above information, you can configure your IdP. We also have guides for configuring various IdP\'s<br>'
    . '<a href="' . $b_url . '/' . drupal_get_path('module', 'miniorange_saml') . '/idp_guides/miniorange_as_idp.pdf" target="_blank">Click here to see the Guide for Configuring miniOrange as IdP. </a><br>',
  );

  $form['markup_15'] = array(
    '#markup' => '<a href="' . $b_url . '/' . drupal_get_path('module', 'miniorange_saml') . '/idp_guides/okta_as_idp.pdf" target="_blank">Click here to see the Guide for Configuring Okta '
    . 'as IdP. </a><br>',
  );

  $form['markup_16'] = array(
    '#markup' => '<div class="mo_saml_highlight_background_note_1"><b>NOTE: </b> We also have step by step do-it-yourself guides available for all known IdPs like ADFS, Centrify, Okta, '
    . 'OneLogin, OpenAM, Oracle Identity Manager, JBoss Keycloak, Salesforce, Shibboleth, SimpleSAML, WSO2 etc.</div><br><br></div>'
  );

      $form['markup_support_1'] = array(
          '#markup' => '<div class="mo_saml_table_layout_support_1"><h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
      );
      $RegisteredEmailandPhone = Utilities::getEmailandPhone();
      $form['miniorange_saml_email_address_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array(
              'placeholder' => 'Enter your Email'
          ),
          '#required' => TRUE,
          '#default_value' => $RegisteredEmailandPhone['email'],
      );

      $form['miniorange_saml_phone_number_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array(
              'placeholder' => 'Enter your Phone Number'
          ),
          '#default_value' => $RegisteredEmailandPhone['phone'],
      );

      $form['miniorange_saml_support_query_support'] = array(
          '#type' => 'textarea',
          '#clos' => '10',
          '#rows' => '5',
          '#attributes' => array(
              'placeholder' => 'Write your query here'
          ),
          '#required' => TRUE,
      );

      $form['miniorange_saml_support_submit_click'] = array(
          '#type' => 'submit',
          '#value' => t('Submit Query'),
      );

      $form['miniorange_saml_support_note'] = array(
          '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div>'
      );

      $form['miniorange_saml_support_div_cust'] = array(

          '#markup' => '</div></div>'
      );

  return $form;

  }
  
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

      $email = $form['miniorange_saml_email_address_support']['#value'];
      $phone = $form['miniorange_saml_phone_number_support']['#value'];
      $query = $form['miniorange_saml_support_query_support']['#value'];
      $support = new MiniOrangeSamlSupport($email, $phone, $query);
      $support_response = $support->sendSupportQuery();
      if($support_response) {
          drupal_set_message(t('Support query successfully sent'));
      }
      else {
          drupal_set_message(t('Error sending support query'), 'error');
      }
  }
}