<?php
/**
 * @file
 * Contains Login Settings for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
 namespace Drupal\miniorange_saml\Form;
 
 use Drupal\Core\Form\FormBase;
 use Drupal\miniorange_saml\MiniorangeSamlSupport;
 use Drupal\miniorange_saml\Utilities;

 class MiniorangeSignonSettings extends FormBase {
	 
  public function getFormId() {
    return 'miniorange_saml_login_setting';
  }
  
  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {

      global $base_url;
  if (\Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_email') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_id') == NULL
    || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_token') == NULL || \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_api_key') == NULL) {
      $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
      $form['header'] = array(
          '#markup' => '<center><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
      );

    return $form;
  }

  global $base_url;

      $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',
      );

      $form['markup_top'] = array(
          '#markup' => '<div class="mo_saml_table_layout container">'
      );

  $form['markup_1'] = array(
    '#markup' => '<h2>Sign in Settings</h2><hr><br/>',
  );

  $form['miniorange_saml_force_auth'] = array(
    '#type' => 'checkbox',
    '#title' => t('Protect website against anonymous access <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b>'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_force_auth'),
    '#disabled' => TRUE,
  );

  $form['markup_2'] = array(
    '#markup' => '<b>Note: </b>Users will be redirected to your IdP for login in case user is not logged in and tries to access website.<br><br>',
  );

  $form['miniorange_saml_auto_redirect'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>auto redirect the user to IdP <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b>'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_auto_redirect_to_idp'),
	'#disabled' => TRUE,
  );

  $form['markup_3'] = array(
    '#markup' => 'Note: Users will be redirected to your IdP for login when the login page is accessed.<br><br>',
  );

  $form['miniorange_saml_enable_backdoor'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>backdoor login <a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b>'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_enable_backdoor'),
    '#disabled' => TRUE,
  );

  $form['markup_4'] = array(
    '#markup' => '<b>Note: </b>Checking this option <b>creates a backdoor to login to your Website using Drupal credentials</b><br>'
    . ' incase you get locked out of your IdP. Note down this URL: <b><a>' . $base_url . '/saml_login=false</a></b><br><br>',
  );
  
  $form['miniorange_saml_default_relaystate'] = array(
    '#type' => 'textfield',
    '#title' => t('Default Redirect URL after login <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[PREMIUM]</a></b>'),
    '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_default_relaystate'),
      '#attributes' => array('style' => 'width:700px','placeholder' => 'Enter Default Redirect URL'),
	'#disabled' => TRUE,
  );
    
  $form['miniorange_saml_gateway_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Configuration'),
      '#disabled' => TRUE,
  );

      $form['main_layout_div_end'] = array(
          '#markup' => '<br><br></div>',
      );

      $form['markup_idp_attr_header_top_support'] = array('#markup' => '<div class="mo_saml_table_layout_support_1">',
      );

      $form['markup_support_1'] = array(
          '#markup' => '<h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
      );
      $RegisteredEmailandPhone = Utilities::getEmailandPhone();
      $form['miniorange_saml_email_address_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array(
              'placeholder' => 'Enter your Email'
          ),
          '#required' => TRUE,
          '#default_value' => $RegisteredEmailandPhone['email'],
      );

      $form['miniorange_saml_phone_number_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array(
              'placeholder' => 'Enter your Phone Number'
          ),
          '#default_value' => $RegisteredEmailandPhone['phone'],
      );

      $form['miniorange_saml_support_query_support'] = array(
          '#type' => 'textarea',
          '#clos' => '10',
          '#rows' => '5',
          '#attributes' => array(
              'placeholder' => 'Write your query here'
          ),
          '#required' => TRUE,
      );

      $form['miniorange_saml_support_submit_click'] = array(
          '#type' => 'submit',
          '#value' => t('Submit Query'),
      );

      $form['miniorange_saml_support_note'] = array(
          '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div>'
      );

      $form['miniorange_saml_support_div_cust'] = array(

          '#markup' => '</div></div>'
      );
  
    return $form;

  }

     public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

         $email = $form['miniorange_saml_email_address_support']['#value'];
         $phone = $form['miniorange_saml_phone_number_support']['#value'];
         $query = $form['miniorange_saml_support_query_support']['#value'];
         $support = new MiniOrangeSamlSupport($email, $phone, $query);
         $support_response = $support->sendSupportQuery();
         if($support_response) {
             drupal_set_message(t('Support query successfully sent'));
         }
         else {
             drupal_set_message(t('Error sending support query'), 'error');
         }

     }
 }